<?php
// vim: foldmethod=marker
/**
 *  Ethna_View_404.php
 *
 *  @author     Yoshinari Takaoka <takaoka@beatcraft.com>
 *  @license    http://www.opensource.org/licenses/bsd-license.php The BSD License
 *  @package    Ethna
 *  @version    $Id: 03bf1dc51493754c030ecfae5829ea95f1762996 $
 */

// {{{ Ethna_View_404
/**
 *  404ページ(リソースが存在しない場合のエラーページ)
 *  を出力するビューの実装
 *
 *  @author     Yoshinari Takaoka <takaoka@beatcraft.com>
 *  @access     public
 *  @package    Ethna
 */
class Ethna_View_404 extends Ethna_ViewClass
{
    /**#@+
     *  @access private
     */

    /**#@-*/

    /**
     *  404 ページを出力するための前処理を行う
     *
     *  @access public
     *  @param  array  $param  出力に必要なユーザー定義パラメータ
     */
    function preforward($param = array())
    {
        $this->error(404);
    }

}
// }}}
